# -*- coding: utf-8 -*-
"""ITS307_Assignment_1.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1Uw5z4tMwHCuTwMVtNzaI04YidoDXaJQ5

# ITS307 Data Analytics : Assignment 1

**Gyalpozhing College of Information Technology </br>
Spring Semester 2022**</br>

## Part 1: Drake or Rihanna?

Billboard Magazine puts out a top 100 list of "singles" every week. Information from this list, as well as that from music sales, radio, and other sources is used to determine a top-100 "singles" of the year list. A single is typically one song, but sometimes can be two songs which are on one "single" record.

In this homework you will:

1. Read data from ``yearinfo.json`` which is scraped from Wikipedia to obtain information about the best singers and groups from each year (distinguishing between the two groups) as determined by the Billboard top 100 charts. You will have to clean this data.First you will learn how to read data from json files and create dataframe.

2. Use pandas and matplotlib to represents and explore data

### 1.1 Loading data from json file

Load our JSON file into the ``yearinfo`` variable, just to be sure everything is working.
"""

#Write your code here, You may need to use python open() function to open the file and load data.
import pandas as pd
import matplotlib as plt

import json
with open('yearinfo.json','r') as json_file:
  yearinfo =json.load(json_file)
print(yearinfo)

"""Display the key values of first 5 of 2010"""

year = yearinfo['2010']
year[:5]

"""### 1.2 Constructing dataframe from `yearinfo`

Construct a year-song-singer dataframe from the yearly information

Let's construct a dataframe **`df`** from the `yearinfo`. The frame should be similar to the frame below. Each row of the frame represents a song, and carries with it the chief properties of year, song, singer, and ranking.

![image-3.png](attachment:image-3.png)

To construct the dataframe, we'll need to iterate over the years and the singles per year. Notice how, above, the dataframe is ordered by ranking and then year. While the exact order is up to you, note that you will have to come up with a scheme to order the information.

Check that the dataframe has sensible data types. You will also likely find that the year field has become an "object" (Pandas treats strings as generic objects): this is due to the conversion to and back from JSON. Such conversions need special care. Fix any data type issues with `df`. (See Pandas astype function.) We will use this `df` in the next question.
"""

#write your code here
data_list = []
for key, values in yearinfo.items():
  for i in values:
    data_list.append(list(i.values()) + [key])
type(data_list)

#converting list into dataframe
df = pd.DataFrame(data_list)
df.head(1)

#renaming all the columns
df.columns = ['band_singer','song','songurl','ranking','titletext','url','year']
df.head()

df.isnull().sum()

df.dtypes

#changing dtype of year into int
df.year = df.year.astype('int')

df.dtypes

"""### 1.3 Who are the highest quality singers?

Here we show the highest quality singers and plot them on a bar chart.

#### Find highest quality singers according to how prolific they are

What do we mean by highest quality? This is of course open to interpretation, but let's define "highest quality" here as the number of times a singer appears in the top 100 over this time period. If a singer appears twice in a year (for different songs), this is counted as two appearances, not one. 

Make a bar-plot of the most prolific singers. Singers on this chart should have appeared at-least more than 15 times. (HINT: look at the docs for the pandas method `value_counts`.)
"""

#Sorting band_singer in list
def get_singer(s):
  singer = s[0]
  return singer
df['band_singer'] = df.band_singer.map(get_singer)
df['song'] = df.song.map(get_singer)
df['songurl'] = df.songurl.map(get_singer)
df['url'] = df.url.map(get_singer)
df.head()

#Determing highest frequcies band_singer
best_singer = df['band_singer'].value_counts()[:20]
data = pd.DataFrame(best_singer)
data

print(type(data))
greater_15 = data.loc[data['band_singer'] >= 15 ] # Selecting whose frequencies is greater than 15
greater_15

# Commented out IPython magic to ensure Python compatibility.
#Ploting bar plot
import matplotlib.pyplot as plt
# %matplotlib inline
greater_15['band_singer'].plot(kind="bar")
plt.title("highest quality singers")
plt.xlabel("band_singer")
plt.ylabel("Frequencies")

data.columns

"""**Question: Who is the most profilic singer?**

### 1.4 What if we used a different metric?

What we would like to capture is this: a singer should to be scored higher if the singer appears higher in the rankings. So we'd say that a singer who appeared once at a higher and once at a lower ranking is a "higher quality" singer than one who appeared twice at a lower ranking.

To do this, group all of a singers songs together and assign each song a score 101 - ranking. Order the singers by their total score and make a bar chart for the top 20.
"""

#write your code here
#Creating new dataframe as metric_data
metric_df = df
metric_df.head(5)

# Fetching single ranking value
ranking = metric_df.ranking[0]
type(ranking)
print(type(ranking))

# Creating new score column
def get_ranking(ranking):
  score = 101 - ranking
  return score

metric_df['score'] = metric_df.ranking.map(get_ranking)
metric_df.head(5)

# Sorting score column
metric_df.sort_values(['score'],ascending = False, inplace = True)
metric_df.head()

# Creating new dataframe
total_data = metric_df[['band_singer','score']]
total_data.head()

# Total score of band_singer
total_score = total_data.groupby('band_singer').sum()
t = total_score.sort_values(by = 'score', ascending = False)
t = t['score'][:20]# Selecting Top 20 singers

# Ploting bar plot
top_20 = pd.DataFrame(t)
top_20['score'].plot(kind = "bar")
plt.ylabel('score')
plt.title("Top 20 singers")

"""**Question:Do you notice any major differences when you change the metric? How have the singers at the top shifted places? Why do you think this happens?**

## Part 2: Using group properties

Frame any questions that you want to answer using group properties and interpret your result using appropriate visualizations.
"""

# Find the best singer of the particular year by using most frequency

#write your solution from here
# Total groups
len(df.groupby('year'))

df.head(5)

# Framing new dataframe from df dataframe
new_data = df[['band_singer','ranking','year']]
# Grouping by year
year = new_data.groupby('year')
# Selecting particular group
year = year.get_group(2011)
# Finding highest frequency over particular group
highest_frequency = year['band_singer'].value_counts(sort = True)[:10]
highest_frequency

# Converting series to DataFrame
year2011 = pd.DataFrame(highest_frequency)
year2011

# Plotting bar plot
year2011['band_singer'].plot(kind = "bar")
plt.title("Top 10 among year 2011")
plt.xlabel('band_singer')
plt.ylabel('Frequency')

"""## SUBMISSION DATE: 2nd April 2022 """